import numpy as np
import pandas as pd
import os



ids_casa_17 = np.array([340, 341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364])
ids_fridge = np.array([6,23,46,69,105,106,107,129,195,196,197,198,199,333,
                       334,459,460,461,462,528,529,530,546,547,631,632,633,634,
                       635,686,710,799,922,933,950,1011,1037,1063])

#
data_id_elec_90 = np.loadtxt(os.path.join('data','90.csv'), delimiter=',')
I_V_a = (data_id_elec_90[:500,0], data_id_elec_90[:500,1])
I_V_b = (data_id_elec_90[30000:31500,0], data_id_elec_90[30000:31500,1])
I_V_c = (data_id_elec_90[49500:,0], data_id_elec_90[49500:,1])
I_V_d = (data_id_elec_90[43560:45760,0], data_id_elec_90[43560:45760,1])
I_V_e = (data_id_elec_90[43560:55880,0], data_id_elec_90[43560:55880,1])

I_V_b_0 = I_V_b[0]
ciclo_promedio_I_V_b_0_a = (I_V_b_0[0:500] + I_V_b_0[500:1000] +  I_V_b_0[1000:1500])/3 #30000,60
ciclo_promedio_I_V_b_0_b = (I_V_b_0[0:560] + I_V_b_0[560:1120])/2  #28000, 50
ciclo_promedio_I_V_b_0_c = (I_V_b_0[0:370] + I_V_b_0[370:740] + I_V_b_0[740:1110] + I_V_b_0[1110:1480])/4 #22200,60

ciclo_I = I_V_b[0][:500]
ciclo_V = I_V_b[1][:500]
ciclo_I_alineado = np.roll(ciclo_I,-284)
ciclo_V_alineado = np.roll(ciclo_V,-284)



tests = {'get_cantidad_electrodomesticos':[{'params':(),'expected_result':1074}],
         'get_tipo':[{'params':(10,),'expected_result':8},
                     {'params':(101,),'expected_result':2},
                     {'params':(987,),'expected_result':0}],
         'get_casa':[{'params':(10,),'expected_result':1},
                     {'params':(101,),'expected_result':6},
                     {'params':(987,),'expected_result':51}],
         'get_nombre':[{'params':(10,),'expected_result':'Microwave'},
                       {'params':(101,),'expected_result':'Fan'},
                       {'params':(987,),'expected_result':'Air Conditioner'}],
         'get_ids_por_casa':[{'params':(17,),'expected_result':ids_casa_17}],
         'get_ids_por_tipo':[{'params':(3,),'expected_result':ids_fridge}],
         'cargar_VI_por_ciclos':[{'params':(os.path.join('data','90.csv'), 30000, 60, 1, 0) ,'expected_result':I_V_a},
                                 {'params':(os.path.join('data','90.csv'), 30000, 60, 3, 60) ,'expected_result':I_V_b},
                                 {'params':(os.path.join('data','90.csv'), 30000, 60, 20, 99) ,'expected_result':I_V_c},
                                 {'params':(os.path.join('data','90.csv'), 22000, 50, 5, 99) ,'expected_result':I_V_d},
                                 {'params':(os.path.join('data','90.csv'), 22000, 50, 40, 99) ,'expected_result':I_V_e}
                                 ], 
        'promediar_ciclos':[{'params':(I_V_b[0], 30000, 60) ,'expected_result':ciclo_promedio_I_V_b_0_a},
                            {'params':(I_V_b[0], 28000, 50) ,'expected_result':ciclo_promedio_I_V_b_0_b},
                            {'params':(I_V_b[0], 22200, 60) ,'expected_result':ciclo_promedio_I_V_b_0_c},],

        'alinear_ciclo_I_V':[{'params':(ciclo_I, ciclo_V) ,'expected_result':(ciclo_I_alineado, ciclo_V_alineado)}],
         

        }


def run_test(functions):

   
    function_names = [f.__name__ for f in functions]
    
    test_results = []

    for i, function in enumerate(functions):
        function_name = function_names[i]
        if not function_name in tests:
            test_result = [function_name, '-', '-', 'Test no implementado']
            test_results.append(test_result)
            continue

        tests_to_run = tests[function_name]
        for t in tests_to_run:
            params = t['params']
            function_result = function(*params)
            expected_result = t['expected_result']
            # print(function_result)
            # print(expected_result)
            verifica = np.array_equal(function_result,expected_result)
            
            
            test_result = [function_name, params, expected_result, function_result, verifica]
            
            test_results.append(test_result)
            
            
    df = pd.DataFrame(test_results, columns=['Función', 'Parametros', 'Resultado esperado', 'Resultado función', 'Verifica'])

    return df
        


