import numpy as np
import pandas as pd
import os



ids_casa_17 = np.array([320, 321, 322, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332,
                        333, 334, 335, 336, 337, 338, 339, 340, 341, 342, 343, 344])
ids_fridge = np.array([   6,   17,   39,   61,   93,   94,   95,  117,  183,  184,  185,
        186,  187,  313,  314,  433,  434,  435,  436,  502,  503,  504,
        520,  521,  605,  606,  607,  658,  681,  766,  884,  895,  912,
        968,  994, 1015, 1037, 1038, 1039, 1040, 1041, 1127, 1128, 1129,
       1130, 1131, 1226, 1227, 1228, 1229, 1230, 1293, 1294, 1295, 1296,
       1297, 1358, 1359, 1360, 1361, 1362, 1363, 1364, 1473, 1474, 1475,
       1476, 1477, 1532, 1533, 1534, 1535, 1536, 1660, 1661, 1662, 1663,
       1664, 1665, 1666, 1667, 1668, 1669, 1720, 1721, 1722, 1723, 1724])

#
data_id_elec_90 = np.loadtxt(os.path.join('data','90.csv'), delimiter=',')
I_V_a = (data_id_elec_90[:500,0], data_id_elec_90[:500,1])
I_V_b = (data_id_elec_90[30000:31500,0], data_id_elec_90[30000:31500,1])
I_V_c = (data_id_elec_90[49500:,0], data_id_elec_90[49500:,1])
I_V_d = (data_id_elec_90[43560:45760,0], data_id_elec_90[43560:45760,1])
I_V_e = (data_id_elec_90[43560:55880,0], data_id_elec_90[43560:55880,1])

I_V_b_0 = I_V_b[0]
ciclo_promedio_I_V_b_0_a = (I_V_b_0[0:500] + I_V_b_0[500:1000] +  I_V_b_0[1000:1500])/3 #30000,60
ciclo_promedio_I_V_b_0_b = (I_V_b_0[0:560] + I_V_b_0[560:1120])/2  #28000, 50
ciclo_promedio_I_V_b_0_c = (I_V_b_0[0:370] + I_V_b_0[370:740] + I_V_b_0[740:1110] + I_V_b_0[1110:1480])/4 #22200,60

ciclo_I = I_V_b[0][:500]
ciclo_V = I_V_b[1][:500]
ciclo_I_alineado = np.roll(ciclo_I,-284)
ciclo_V_alineado = np.roll(ciclo_V,-284)



tests = {'get_cantidad_electrodomesticos':[{'params':(),'expected_result':1744}],
         'get_tipo':[{'params':(10,),'expected_result':0},
                     {'params':(101,),'expected_result':4},
                     {'params':(987,),'expected_result':6}],
         'get_casa':[{'params':(10,),'expected_result':2},
                     {'params':(101,),'expected_result':6},
                     {'params':(987,),'expected_result':54}],
         'get_nombre':[{'params':(10,),'expected_result':'Air Conditioner'},
                       {'params':(101,),'expected_result':'Hairdryer'},
                       {'params':(987,),'expected_result':'Incandescent Light Bulb'}],
         'get_ids_por_casa':[{'params':(17,),'expected_result':ids_casa_17}],
         'get_ids_por_tipo':[{'params':(3,),'expected_result':ids_fridge}],
         'cargar_VI_por_ciclos':[{'params':(os.path.join('data','90.csv'), 30000, 60, 1, 0) ,'expected_result':I_V_a},
                                 {'params':(os.path.join('data','90.csv'), 30000, 60, 3, 60) ,'expected_result':I_V_b},
                                 {'params':(os.path.join('data','90.csv'), 30000, 60, 20, 99) ,'expected_result':I_V_c},
                                 {'params':(os.path.join('data','90.csv'), 22000, 50, 5, 99) ,'expected_result':I_V_d},
                                 {'params':(os.path.join('data','90.csv'), 22000, 50, 40, 99) ,'expected_result':I_V_e}
                                 ], 
        'promediar_ciclos':[{'params':(I_V_b[0], 30000, 60) ,'expected_result':ciclo_promedio_I_V_b_0_a},
                            {'params':(I_V_b[0], 28000, 50) ,'expected_result':ciclo_promedio_I_V_b_0_b},
                            {'params':(I_V_b[0], 22200, 60) ,'expected_result':ciclo_promedio_I_V_b_0_c},],

        'alinear_ciclo_I_V':[{'params':(ciclo_I, ciclo_V) ,'expected_result':(ciclo_I_alineado, ciclo_V_alineado)}],
         

        }


def run_test(functions):

   
    function_names = [f.__name__ for f in functions]
    
    test_results = []

    for i, function in enumerate(functions):
        function_name = function_names[i]
        if not function_name in tests:
            test_result = [function_name, '-', '-', 'Test no implementado']
            test_results.append(test_result)
            continue

        tests_to_run = tests[function_name]
        for t in tests_to_run:
            params = t['params']
            function_result = function(*params)
            expected_result = t['expected_result']
            # print(function_result)
            # print(expected_result)
            verifica = np.array_equal(function_result,expected_result)
            
            
            test_result = [function_name, params, expected_result, function_result, verifica]
            
            test_results.append(test_result)
            
            
    df = pd.DataFrame(test_results, columns=['Función', 'Parametros', 'Resultado esperado', 'Resultado función', 'Verifica'])

    return df
        


